// The following code may be used to convert between Intel and DEC format floats

float ConvertDecToFloat(char bytes[4])
{
	char p[4];
	p[0] = bytes[2];
	p[1] = bytes[3];
	p[2] = bytes[0];
	p[3] = bytes[1];
	if (p[0] || p[1] || p[2] || p[3])
		--p[3];          // adjust exponent

	return *(float*)p;
}


void ConvertFloatToDec(float f, char* bytes)
{
	char* p = (char*)&f;
	bytes[0] = p[2];
	bytes[1] = p[3];
	bytes[2] = p[0];
	bytes[3] = p[1];
	if (bytes[0] || bytes[1] || bytes[2] || bytes[3])
		++bytes[1];      // adjust exponent
}


// Convert between DEC, Intel SGI/MIPS float formats

enum EProcessorType
{
	EPCProcessor = 1,
	EDECProcessor = 2,
	EMIPSProcessor = 3
};
void ConvertFloats(int a_InType, int a_OutType, float* a_pData, int a_Count)
//
// Based on code by Andrew Danis (February 1993), originally in FORTRAN
//
{
	static const char s_ExponentByteLUT[3] = { 3, 1, 0 };
	static const char s_SwapOrderLUT[3][3][4] =
	{ 0,1,2,3, 2,3,0,1, 3,2,1,0,
	  2,3,0,1, 0,1,2,3, 1,0,3,2,
	  3,2,1,0, 1,0,3,2, 0,1,2,3 };

	static const char s_ExponentAdditionLUT[3][3] =
	{ 0, -1, 0,
		1,  0, 1,
		0, -1, 0 };

	if (a_InType != a_OutType && a_Count > 0)
	{
		// Coversion type parameters
		unsigned char SwapOrder[4];
		unsigned char ExponentByte;
		char ExponentAddition;

		// working variables
		int c;
		unsigned char WorkingValue[4];
		unsigned long FloatIndex;

		// Determine which byte contains the exponent
		ExponentByte = s_ExponentByteLUT[a_OutType - 1];

		// and the addition
		ExponentAddition = s_ExponentAdditionLUT[a_OutType - 1][a_InType - 1];

		// Choose the swap order
		for (c = 0; c < 4; c++)
			SwapOrder[c] = s_SwapOrderLUT[a_OutType - 1][a_InType - 1][c];

		a_FloatCount *= 4;
		for (FloatIndex = 0; FloatIndex < a_FloatCount; FloatIndex += 4)
		{
			// Get the bytes in the right order
			for (c = 0; c < 4; c++)
				WorkingValue[SwapOrder[c]] =
				((unsigned char*)a_pData)[FloatIndex + c];

			// If the value is non-zero (?), apply the exponent conversion
			if (WorkingValue[0] || WorkingValue[1]
				|| WorkingValue[2] || WorkingValue[3])
				WorkingValue[ExponentByte] =
				(unsigned char)(WorkingValue[ExponentByte] + ExponentAddition);

			// Put the converted float back in the data array
			for (c = 0; c < 4; c++)
				((unsigned char*)a_pData)[FloatIndex + c] = WorkingValue[c];
		}
	}
}


