	SUBROUTINE GETF(LU,DTYP,FRN,NPTS,NANLG,AVRAT,FROUT,IH,IVLA,
     *	   SCALE,INTYP)
C
C	*******************************************
C	*    Copyright (C)    A.Dainis  (1987)    *
C	*          All rights reserved            *
C	*******************************************
C------------------------------------------------------------
C
C  Subroutine to fetch 1 frame of data from a .C3D file. 
C  Before this subroutine is first called, the data file must be 
C  opened as logical unit LU, and the record pointer must be
C  initialized as IVLA=0 .
C
C  If SCALE factor is negative, then the data is assumed to be
C  stored in REAL*4 format in the .C3D file.
C
C  On error, IVLA is returned as -1
C------------------------------------------------------------
C
C INPUT:
	INTEGER*2 LU		! logical unit number of .C3D data file
	INTEGER*2 DTYP		! =1 if want point data and analog data
C				! at point data frame rate, =2 for analog
C				! data at analog frame rate
	INTEGER*2 FRN		! frame number of data to get
	INTEGER*2 NPTS		! number of points in video frame
	INTEGER*2 NANLG		! number of analog words in analog frame
	INTEGER*2 AVRAT		! ratio of analog to video frame rates
	INTEGER*2 IH		! number of first data record in file
	INTEGER*2 IVLA		! data record pointer, initially must be
	REAL*4	  SCALE		! scale factor for integer data in .C3D file
C				!   also to be use for residual in REAL*4 
C				!   data file
C				!       to zero
C OUTPUT:
	REAL*4 FROUT(1)		! output data frame
C		  IVLA		! is set to -1 if error in getting frame
C-----------------------------------------------------------------------
	INTEGER*2 IBUF(256)	! record buffer
	REAL*4	  RBUF(128)
C
	EQUIVALENCE (IBUF(1),RBUF(1))
C-----------------------------------------------------------------------
	MATYP=1 					! for PC

	IRE=0				! integer data file
	IBZ=256 			! record lenght			
	IF(SCALE.GE.0.0) GOTO 7		
	IRE=1				! real*4 data file
	IBZ=128	
    7	SC=ABS(SCALE)
C
	LF=NPTS*4+NANLG*AVRAT		! total frame length
	GOTO (11,12),DTYP
C
   11	FP=FLOAT(FRN-1)*LF		! word # for frame start - 1
	GOTO 13
C
   12	IFR=(FRN-1)/AVRAT		! data frame needed - 1
	INFR=FRN-IFR*AVRAT		! analog frame within video frame
	FP=FLOAT(IFR)*FLOAT(LF)+NPTS*4+(INFR-1)*NANLG	
C
   13	IVV=FP/FLOAT(IBZ)+.001		! record number
	J=(FP-FLOAT(IVV)*FLOAT(IBZ))+.001 	! frame start in record
C----------------------------------------------------------------
	IVV=IVV+IH			! record # needed
	IF(IVV.EQ.IVLA) GO TO 45	! have it, don't need to read it
	IVLA=IVV
	READ(LU,REC=IVLA,ERR=800) IBUF

	IF(INTYP.NE.MATYP) THEN
	    IF(IRE.EQ.0) CALL ICONV(INTYP,MATYP,IBUF,256)
	    IF(IRE.EQ.1) CALL RCONV(INTYP,MATYP,IBUF,128)
	ENDIF
C
   45	LFF=NPTS*4+NANLG*AVRAT
	IF(DTYP.EQ.2) LFF=NANLG
C
	K=1
	DO 20 I=1,LFF			! transfer to output frame
	J=J+1
	IF(J.LE.IBZ) GO TO 30
	J=1				! need next record
	IVLA=IVLA+1
	READ(LU,REC=IVLA,ERR=800) IBUF

	IF(INTYP.NE.MATYP) THEN
	    IF(IRE.EQ.0) CALL ICONV(INTYP,MATYP,IBUF,256)
	    IF(IRE.EQ.1) CALL RCONV(INTYP,MATYP,IBUF,128)
	ENDIF

   30	IF(IRE.EQ.0) FROUT(K)=IBUF(J)		! integer read
	IF(IRE.EQ.1) FROUT(K)=RBUF(J)		! real*4  read
   20	K=K+1

	GOTO 90
C
  800   IVLA=-1				! ERROR
C
   90	RETURN
	END
